searchNodes=[{"doc":"Supports use of GraphQL documents inside Phoenix controllers.ExampleFirst, use Absinthe.Phoenix.Controller, passing your schema and notifying Absinthe to operate in internal mode:defmodule MyAppWeb.UserController do use MyAppWeb, :controller use Absinthe.Phoenix.Controller, schema: MyAppWeb.Schema, action: [mode: :internal] # ... actions endFor each action you want Absinthe to process, provide a GraphQL document using the @graphql module attribute (before the action):@graphql &quot;&quot;&quot; query ($filter: UserFilter) { users(filter: $filter, limit: 10) } &quot;&quot;&quot; def index(conn, %{data: data}) do render conn, &quot;index.html&quot;, data endThe params for the action will be intercepted by the Absinthe.Phoenix.Controller.Action plug, and used as variables for the GraphQL document you've specified.For instance, given a definition for a :user_filter input object type like this:input_object :user_filter do field :name_matches, :string field :age_above, :integer field :age_below, :integer endAnd a query that looks like this (assuming you have the normal Plug.Parsers configuration for param parsing):?filter[name_matches]=joe&amp;filter[age_above]=42Then Absinthe will receive variable definitions of:%{&quot;filter&quot; =&gt; %{&quot;name_matches&quot; =&gt; &quot;joe&quot;, &quot;age_above&quot; =&gt; 42}}(For how the string &quot;42&quot; was converted into 42, see cast_param/3).The params on the conn will then be replaced by the result of the execution by Absinthe. The action function can then match against that result to respond correctly to the user:It's up to you to handle the three possible results:When there's :data but no :errors, everything went perfectly.When there's :errors but no :data, a validation error occurred and the document could not be executed.When there's :data and :errors, partial data is available but some fields reported errors during execution.Notice the keys are atoms, not strings as in normal Phoenix action invocations.Differences with the GraphQL SpecificationThere are some important differences between GraphQL documents as processed in an HTTP API and the GraphQL documents that this module supports.In an effort to make use of GraphQL ergonomic in Phoenix controllers and views, Absinthe supports some slight structural modifications to the GraphQL documents provided using the @graphql module attribute in controller modules.In a way, you can think of these changes as a specialized GraphQL dialect. The following are the differences you need to keep in mind.Objects can be leaf nodesLet's look at the users example mentioned before:@graphql &quot;&quot;&quot; query ($filter: UserFilter) { users(filter: $filter, limit: 10) } &quot;&quot;&quot;You'll notice that in the above example, users doesn't have an accompanying selection set (that is, a set of child fields bounded by { ... }). The GraphQL specification dictates that only scalar values can be &quot;leaf nodes&quot; in a GraphQL document... but to support unmodified struct values being returned (for example, Ecto schemas), if no selection set is provided for an object value (or list thereof), the entire value is returned.The template can then use users as needed:&lt;ul&gt; &lt;%= for user &lt;- @users do %&gt; &lt;li&gt;&lt;%= link user.full_name, to: user_path(@conn, :show, user) %&gt;&lt;/li&gt; &lt;% end %&gt; &lt;/ul&gt;This is useful for Phoenix.HTML helper functions that expect structs with specific fields (especially form_for).One way to think of this change is that, for objects, no selection set is equivalent to a &quot;splat&quot; operator (except, of course, even fields not defined in your GraphQL schema are returned as part of the value).But, never fear, nothing is stopping you from ignoring this behavior and providing a selection set if you want a traditionally narrow set of fields:@graphql &quot;&quot;&quot; query ($filter: UserFilter) { users(filter: $filter, limit: 10) { id full_name } } &quot;&quot;&quot;Scalar values aren't serializedTo remove the need for reparsing values, scalar values aren't serialized; Phoenix actions receive the original, unserialized values of GraphQL fields.This is especially useful for custom scalar types. Using a couple of the additional types packaged in Absinthe.Type.Custom, for example::decimal values are returned as %Decimal{} structs, not strings.:datetime values are returned as %DateTime{} structs, not strings.In short, GraphQL used in controllers is a query language to retrieve the values requested---there's no need to serialize the values to send them across HTTP.Fields use snake_caseUnlike in the GraphQL notation scheme we prefer for GraphQL APIs (that is, camelCase fields, which better match up with the expectations of JavaScript clients), fields used in documents provided as @graphql should use snake_case naming, as Elixir conventions use that notation style for atoms, etc.Atom keysBecause you are writing the GraphQL document in your controller and Absinthe is validating the document against your schema, atom keys are returned for field names.","ref":"Absinthe.Phoenix.Controller.html","title":"Absinthe.Phoenix.Controller","type":"behaviour"},{"doc":"Customize the Absinthe processing pipeline.Only implement this function if you need to change the pipeline used to process documents.","ref":"Absinthe.Phoenix.Controller.html#c:absinthe_pipeline/2","title":"Absinthe.Phoenix.Controller.absinthe_pipeline/2","type":"callback"},{"doc":"Cast string param values to values Absinthe expects for variable input.Some scalar types, like :integer (GraphQL Int) require that raw, incoming value be a non-string type. This isn't a problem in GraphQL-over-HTTP because the variable values are provided as a JSON payload (which supports, i.e., integer values).To support converting incoming param values to the format that certain scalars expect, we support a cast_param/3 callback function that takes a raw value, target type (e.g., the scalar type), and the schema, and returns the transformed value. cast_param/3 is overridable and the implementation already supports :integer and :float types.If you override cast_param/3, make sure you super or handle lists, non-nulls, and input object values yourself; they're also processed using the function.Important: In the event that a value is invalid, just return it unchanged so that Absinthe's usual validation logic can report it as invalid.","ref":"Absinthe.Phoenix.Controller.html#c:cast_param/3","title":"Absinthe.Phoenix.Controller.cast_param/3","type":"callback"},{"doc":"","ref":"Absinthe.Phoenix.Controller.html#default_pipeline/2","title":"Absinthe.Phoenix.Controller.default_pipeline/2","type":"function"},{"doc":"","ref":"Absinthe.Phoenix.Controller.html#variables/1","title":"Absinthe.Phoenix.Controller.variables/1","type":"function"},{"doc":"","ref":"Absinthe.Phoenix.Endpoint.html","title":"Absinthe.Phoenix.Endpoint","type":"module"},{"doc":"Absinthe.Phoenix.Socket is used as a module for setting up a control channel for handling GraphQL subscriptions.Examplesdefmodule MyApp.Web.UserSocket do use Phoenix.Socket use Absinthe.Phoenix.Socket, schema: MyApp.Web.Schema transport :websocket, Phoenix.Transports.WebSocket def connect(params, socket) do socket = Absinthe.Phoenix.Socket.put_options(socket, [ context: %{current_user: find_current_user(params)} ]) {:ok, socket} end def id(_socket), do: nil endPhoenix 1.2If you're on Phoenix 1.2 see put_schema/2.","ref":"Absinthe.Phoenix.Socket.html","title":"Absinthe.Phoenix.Socket","type":"module"},{"doc":"Configure Absinthe options for a socket.Examplesdef connect(params, socket) do current_user = current_user(params) socket = Absinthe.Phoenix.Socket.put_options(socket, context: %{ current_user: current_user }) {:ok, socket} end defp current_user(%{&quot;user_id&quot; =&gt; id}) do MyApp.Repo.get(User, id) end","ref":"Absinthe.Phoenix.Socket.html#put_options/2","title":"Absinthe.Phoenix.Socket.put_options/2","type":"function"},{"doc":"Configure the schema for a socket.Only use this if you are not yet on Phoenix 1.3. If you're on Phoenix 1.3, read the moduledocs.","ref":"Absinthe.Phoenix.Socket.html#put_schema/2","title":"Absinthe.Phoenix.Socket.put_schema/2","type":"function"},{"doc":"Convenience functions for subscription tests.","ref":"Absinthe.Phoenix.SubscriptionTest.html","title":"Absinthe.Phoenix.SubscriptionTest","type":"module"},{"doc":"","ref":"Absinthe.Phoenix.SubscriptionTest.html#join_absinthe/1","title":"Absinthe.Phoenix.SubscriptionTest.join_absinthe/1","type":"function"},{"doc":"A small wrapper around Phoenix.ChannelTest.push/3.The only option that is used is opts[:variables] - all other options are ignored.","ref":"Absinthe.Phoenix.SubscriptionTest.html#push_doc/3","title":"Absinthe.Phoenix.SubscriptionTest.push_doc/3","type":"function"},{"doc":"","ref":"Absinthe.Phoenix.Types.html","title":"Absinthe.Phoenix.Types","type":"module"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Phoenix.PubSub 2.0 support","ref":"changelog.html#v2-0-0-2020-05-14","title":"Changelog - v2.0.0 - 2020-05-14","type":"extras"},{"doc":"Absinthe 1.5 support","ref":"changelog.html#v1-5-0-2020-05-14","title":"Changelog - v1.5.0 - 2020-05-14","type":"extras"},{"doc":"Remove unintentional poison dependency","ref":"changelog.html#v1-4-4-2019-05-04","title":"Changelog - v1.4.4 - 2019-05-04","type":"extras"},{"doc":"Add variables/1 function to make it easy to get the original parameters","ref":"changelog.html#v1-4-2-2018-01-22","title":"Changelog - v1.4.2 - 2018-01-22","type":"extras"},{"doc":"Deprecate Absinthe.Phoenix.Socket.put_opts/2 in favor of Absinthe.Phoenix.Socket.put_options/2 for consistency with Absinthe.Plug","ref":"changelog.html#v1-4-1-2018-01-21","title":"Changelog - v1.4.1 - 2018-01-21","type":"extras"},{"doc":"First real release.","ref":"changelog.html#v1-4-0-2017-11-13","title":"Changelog - v1.4.0 - 2017-11-13","type":"extras"},{"doc":"ContributingThank you for contributing to the project. We'd love to see your issues and pull requests.If you're creating a pull request, please consider these suggestions:Fork, then clone the repo:git clone git@github.com:your-username/absinthe_phoenix.gitInstall the dependencies:mix deps.getMake sure the tests pass:mix testMake your change. Add tests for your change. Make the tests pass:mix testPush to your fork (preferably to a non-master branch) and submit a pull request.We'll review and answer your pull request as soon as possible. We may suggest some changes, improvements, or alternatives. Let's work through it together.Some things that will increase the chance that your pull request is accepted:Write tests.Include @typedocs, @specs, and @docsTry to match the style conventions already present (and Elixir conventions, generally).Write a good commit message.Thanks again for helping!","ref":"contributing.html","title":"Contributing","type":"extras"},{"doc":"Code of ConductContact: conduct@absinthe-graphql.org","ref":"code_of_conduct.html","title":"Code of Conduct","type":"extras"},{"doc":"As contributors and maintainers of this project, we are committed to providing a friendly, safe and welcoming environment for all, regardless of age, disability, gender, nationality, race, religion, sexuality, or similar personal characteristic.The goal of the Code of Conduct is to specify a baseline standard of behavior so that people with different social values and communication styles can talk about the Absinthe project effectively, productively, and respectfully, even in face of disagreements. The Code of Conduct also provides a mechanism for resolving conflicts in the community when they arise.","ref":"code_of_conduct.html#why-have-a-code-of-conduct","title":"Code of Conduct - Why have a Code of Conduct?","type":"extras"},{"doc":"These are the values developers that participate in Absinthe project-related activities should aspire to:Be friendly and welcomingBe patientRemember that people have varying communication styles and that not everyone is using their native language. (Meaning and tone can be lost in translation.)Be thoughtfulProductive communication requires effort. Think about how your words will be interpreted.Remember that sometimes it is best to refrain entirely from commenting.Be respectfulIn particular, respect differences of opinion. It is important that we resolve disagreements and differing views constructively.Avoid destructive behaviorDerailing: stay on topic; if you want to talk about something else, start a new conversation.Unconstructive criticism: don't merely decry the current state of affairs; offer (or at least solicit) suggestions as to how things may be improved.Snarking (pithy, unproductive, sniping comments).The following actions are explicitly forbidden:Insulting, demeaning, hateful, or threatening remarks.Discrimination based on age, disability, gender, nationality, race, religion, sexuality, or similar personal characteristic.Bullying or systematic harassment.Unwelcome sexual advances.Incitement to any of these.","ref":"code_of_conduct.html#our-values","title":"Code of Conduct - Our Values","type":"extras"},{"doc":"If you participate in or contribute to the Absinthe project ecosystem in any way, you are encouraged to follow the Code of Conduct while doing so.Explicit enforcement of the Code of Conduct applies to the official mediums operated by the Absinthe project:The official GitHub projects and code reviews.The absinthe-graphql.org website and documentation.The #absinthe-graphql Slack channel.Activities related to Absinthe (conference talks, meetups, and other unofficial forums) are encouraged to adopt this Code of Conduct. Such groups must provide their own contact information.Project maintainers may remove, edit, or reject comments, commits, code, wiki edits, issues, and other contributions that are not aligned to this Code of Conduct.Instances of abusive, harassing, or otherwise unacceptable behavior may be reported by emailing: conduct@absinthe-graphql.org. All complaints will be reviewed and investigated and will result in a response that is deemed necessary and appropriate to the circumstances. All reports will be kept confidential.The goal of the Code of Conduct is to resolve conflicts in the most harmonious way possible. We hope that in most cases issues may be resolved through polite discussion and mutual agreement. Bannings and other forceful measures are to be employed only as a last resort. Do not post about the issue publicly or try to rally sentiment against a particular individual or group.","ref":"code_of_conduct.html#where-does-the-code-of-conduct-apply","title":"Code of Conduct - Where does the Code of Conduct apply?","type":"extras"},{"doc":"This document was based on the Code of Conduct from the Elixir project, which is based on the Code of Conduct from the Go project with parts derived from Django's Code of Conduct, Rust's Code of Conduct, and the Contributor Covenant.","ref":"code_of_conduct.html#acknowledgements","title":"Code of Conduct - Acknowledgements","type":"extras"},{"doc":"MIT LicenseCopyright (c) 2016 Bruce Williams, Ben WilsonPermission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"Absinthe.Phoenix This package integrates Absinthe subscriptions with Phoenix, so that you can use subscriptions via websockets.For getting started guides on subscriptions see: https://hexdocs.pm/absinthe/subscriptions.htmlFor getting started guides on server side rendering see: https://hexdocs.pm/absinthe/subscriptions.html","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Install from Hex.pm:For Phoenix 1.4, see the v1.5 branch: https://github.com/absinthe-graphql/absinthe_phoenix/tree/v1.5Phoenix 1.5def deps do [ {:absinthe_phoenix, &quot;~&gt; 2.0.0&quot;} ] endNote: Absinthe.Phoenix requires Elixir 1.10 or higher.","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"See CHANGELOG for upgrade steps between versions.You may want to look for the specific upgrade guide in the Absinthe documentation.","ref":"readme.html#upgrading","title":"Overview - Upgrading","type":"extras"},{"doc":"See &quot;Usage,&quot; below, for basic usage information and links to specific resources.Absinthe.Phoenix hexdocs.For the tutorial, guides, and general information about Absinthe-related projects, see http://absinthe-graphql.org.","ref":"readme.html#documentation","title":"Overview - Documentation","type":"extras"},{"doc":"See the GitHub organization.","ref":"readme.html#related-projects","title":"Overview - Related Projects","type":"extras"},{"doc":"You need to have a working Phoenix PubSub configured. Here is what the default looks like if you create a new Phoenix project:config :my_app, MyAppWeb.Endpoint, # ... other config pubsub_server: MyApp.PubSubIn your application supervisor add a line AFTER your existing endpoint supervision line:[ # other children ... MyAppWeb.Endpoint, # this line should already exist {Absinthe.Subscription, MyAppWeb.Endpoint}, # add this line # other children ... ]Where MyAppWeb.Endpoint is the name of your application's phoenix endpoint.In your MyAppWeb.Endpoint module add:use Absinthe.Phoenix.EndpointIn your socket add:use Absinthe.Phoenix.Socket, schema: MyAppWeb.SchemaWhere MyAppWeb.Schema is the name of your Absinthe schema module.That is all that's required for setup on the server.For client side guidance see the guides.","ref":"readme.html#usage","title":"Overview - Usage","type":"extras"},{"doc":"From within GraphiQL: To use Absinthe.Phoenix from within GraphiQL, you need to tell GraphiQL about your websocket endpoint.forward &quot;/graphiql&quot;, Absinthe.Plug.GraphiQL, schema: MyAppWeb.Schema, socket: MyAppWeb.UserSocket","ref":"readme.html#graphiql-usage","title":"Overview - GraphiQL Usage","type":"extras"},{"doc":"The project is under constant improvement by a growing list of contributors, and your feedback is important. Please join us in Slack (#absinthe-graphql under the Elixir Slack account) or the Elixir Forum (tagged absinthe).Please remember that all interactions in our official spaces follow our Code of Conduct.","ref":"readme.html#community","title":"Overview - Community","type":"extras"},{"doc":"Please follow contribution guide.","ref":"readme.html#contributing","title":"Overview - Contributing","type":"extras"},{"doc":"Copyright (c) 2016 Bruce Williams, Ben WilsonReleased under the MIT License, which can be found in LICENSE.md.","ref":"readme.html#copyright-and-license","title":"Overview - Copyright and License","type":"extras"}]